#include <stdio.h>
#include <allegro.h>

// Requires PP20.DLL to run

// BUG: Map 3B crashes the program

#define PLATFORM_GENESIS		0
#define PLATFORM_AMIGA			1
#define PLATFORM_SNES			2

char platform;

/*unsigned char amiga_glv_names[11][] = {
	"MAPSCR.GLV",
	"CHEESE.GLV",
	"SLIME.GLV",
	"SLIMECAV.GLV",
	"ICECREAM.GLV",
	"BUTTER.GLV",
	"CUSTARD.GLV",
	"BLUECHEE.GLV",
	"CHEECAV.GLV",
	"YOGHURT.GLV",
	"CHEEROC.GLV"
}
unsigned char amiga_ins_names[11][] = {
	"",
	"CHEESE.INS",
	"SLIME.INS",
	"SLIMCAVE.INS",
	"ICE.INS",
	"BUTTER.INS",
	"CUSTARD.INS",
	"BLUECHEE.INS",
	"CHEECAVE.INS",
	"YOGHURT.INS",
	"CHEEROCK.INS"
}
unsigned char amiga_itm_names[11][] = {
	"MAP.ITM",
	"CHEESE.ITM",
	"SLIME.ITM",
	"SLIMCAVE.ITM",
	"ICE.ITM",
	"BUTTER.ITM",
	"CUSTARD.ITM",
	"BLUECHEE.ITM",
	"CHEECAVE.ITM",
	"YOGHURT.ITM",
	"CHEEROCK.ITM"
}*/

unsigned char *filename;

FILE *amiga_lvl;
FILE *amiga_glv;
FILE *amiga_ins;
FILE *amiga_itm;

FILE *rom;

char pp20_data[0x8000];

RGB pal0[16];
RGB pal1[16];
RGB pal2[16];
RGB pal3[16];
unsigned char lvl1[0x10000];
unsigned char lvl2[0x10000];
unsigned char glv[0x10000];
unsigned char ins[0x10000];
unsigned char itm[0x10000];
unsigned char map8x8[0x10000];
unsigned char stext[0x660];
unsigned char object_0800[0x3A][0x80];
unsigned char common[0x99][0x20];
unsigned short common_map[0x60];
unsigned int prize_map[0x11];
unsigned short prize_size_x[0x11];
unsigned short prize_size_y[0x11];
unsigned short prize_def_face[0x69];
unsigned short prize_def_spawn[0x69];

BITMAP **tile;
unsigned short number_of_tiles;
short check_blocks_up;
short check_blocks_down;
short check_blocks_left;
short check_blocks_right;

BITMAP *stext_bmp[128];
BITMAP *screen_buffer;
BITMAP *screen_objects;

short res_x = 768;//960;
short res_y = 576;//720;
int cam_x;
int cam_y;
int cam_x_max;
int cam_y_max;

char show_prize = 1;

unsigned char level_number;
//char theme_number;

volatile int tic;
volatile int ticUpdated;

unsigned short swap_endian_16(unsigned short n);
unsigned int swap_endian_32(unsigned int n);
void load_level(unsigned char n);
void explore_map();



void FrameTic(void){
	tic++;
	ticUpdated++;
	
	//if(tic % 60 == 0){
	//	fps = ticLogic60;
	//	ticLogic60 = 0;
	//}
}
END_OF_FUNCTION(FrameTic);



int main(int argc, char **argv){
	allegro_init();
	install_keyboard();
	install_timer();
	
	platform = PLATFORM_GENESIS;
	
	/*if(platform == PLATFORM_AMIGA){
		if(argc > 1)
			filename = argv[1];
		else{
			allegro_message("Filename argument required.");
			allegro_exit();
			exit(0);
		}
	}*/
	
	LOCK_VARIABLE(tic);
	LOCK_VARIABLE(ticUpdated);
	LOCK_FUNCTION(FrameTic);
	install_int_ex(&FrameTic, BPS_TO_TIMER(60));
	
	if(set_gfx_mode(GFX_AUTODETECT_WINDOWED, res_x, res_y, 0, 0) != 0){
		allegro_message(allegro_error);
		allegro_exit();
		exit(0);
	}
	
	allegro_message("Type the 2-digit hex value of the map you wish to load.");
	while(
	 !key[KEY_0] && !key[KEY_1] && !key[KEY_2] && !key[KEY_3] &&
	 !key[KEY_4] && !key[KEY_5] && !key[KEY_6] && !key[KEY_7] && 
	 !key[KEY_8] && !key[KEY_9] && !key[KEY_A] && !key[KEY_B] && 
	 !key[KEY_C] && !key[KEY_D] && !key[KEY_E] && !key[KEY_F]
	);
	if(key[KEY_0])	level_number = 0x00;
	if(key[KEY_1])	level_number = 0x10;
	if(key[KEY_2])	level_number = 0x20;
	if(key[KEY_3])	level_number = 0x30;
	if(key[KEY_4])	level_number = 0x40;
	if(key[KEY_5])	level_number = 0x50;
	if(key[KEY_6])	level_number = 0x60;
	if(key[KEY_7])	level_number = 0x70;
	if(key[KEY_8])	level_number = 0x80;
	if(key[KEY_9])	level_number = 0x90;
	if(key[KEY_A])	level_number = 0xA0;
	if(key[KEY_B])	level_number = 0xB0;
	if(key[KEY_C])	level_number = 0xC0;
	if(key[KEY_D])	level_number = 0xD0;
	if(key[KEY_E])	level_number = 0xE0;
	if(key[KEY_F])	level_number = 0xF0;
	while(
	 key[KEY_0] || key[KEY_1] || key[KEY_2] || key[KEY_3] ||
	 key[KEY_4] || key[KEY_5] || key[KEY_6] || key[KEY_7] ||
	 key[KEY_8] || key[KEY_9] || key[KEY_A] || key[KEY_B] ||
	 key[KEY_C] || key[KEY_D] || key[KEY_E] || key[KEY_F]
	);
	while(
	 !key[KEY_0] && !key[KEY_1] && !key[KEY_2] && !key[KEY_3] &&
	 !key[KEY_4] && !key[KEY_5] && !key[KEY_6] && !key[KEY_7] && 
	 !key[KEY_8] && !key[KEY_9] && !key[KEY_A] && !key[KEY_B] && 
	 !key[KEY_C] && !key[KEY_D] && !key[KEY_E] && !key[KEY_F]
	);
	if(key[KEY_0])	level_number |= 0x0;
	if(key[KEY_1])	level_number |= 0x1;
	if(key[KEY_2])	level_number |= 0x2;
	if(key[KEY_3])	level_number |= 0x3;
	if(key[KEY_4])	level_number |= 0x4;
	if(key[KEY_5])	level_number |= 0x5;
	if(key[KEY_6])	level_number |= 0x6;
	if(key[KEY_7])	level_number |= 0x7;
	if(key[KEY_8])	level_number |= 0x8;
	if(key[KEY_9])	level_number |= 0x9;
	if(key[KEY_A])	level_number |= 0xA;
	if(key[KEY_B])	level_number |= 0xB;
	if(key[KEY_C])	level_number |= 0xC;
	if(key[KEY_D])	level_number |= 0xD;
	if(key[KEY_E])	level_number |= 0xE;
	if(key[KEY_F])	level_number |= 0xF;
	
	if(level_number < 0x70){
		// Load level
		load_level(level_number);
		
		// Explore map
		explore_map();
	}
	else{
		allegro_message("Value must be between 00 and 6F.");
	}
	
	// End program
	allegro_exit();
}
END_OF_MAIN()



void explore_map(){
	int i;
	unsigned short data_address;
	unsigned short data_end;
	unsigned short n;
	unsigned short data_value;
	char pal_offset;
	short x;
	short y;
	unsigned char width;
	unsigned char height;
	BITMAP *block[0x200];
	BITMAP *object_0800_bmp[0x3A];
	BITMAP *prize_block_face[0x11];
	char stext_map[] = " !%'*+,-./0123456789:`\"?@ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	
	// CREATE SMALL TEXT
	n = 0;	// stext[n]
	i = 0;	// stext_map[i]
	while(n < 0x660){
		stext_bmp[stext_map[i]] = create_bitmap(8, 8);
		for(y=0; y < 8; y++){
			for(x=0; x < 8; x += 2){
				stext_bmp[stext_map[i]]->line[y][x] = (stext[n]>>4) + 0x30;
				stext_bmp[stext_map[i]]->line[y][x+1] = (stext[n]&0xF) + 0x30;
				n++;
			}
		}
		i++;
	}
	for(n = 0x00; n < 0x20; n++)
		stext_bmp[n] = stext_bmp[0x20];
	stext_bmp[0x22] = stext_bmp[0x20];
	stext_bmp[0x23] = stext_bmp[0x20];
	stext_bmp[0x24] = stext_bmp[0x20];
	stext_bmp[0x26] = stext_bmp[0x20];
	stext_bmp[0x28] = stext_bmp[0x20];
	stext_bmp[0x29] = stext_bmp[0x20];
	stext_bmp[0x3B] = stext_bmp[0x20];
	stext_bmp[0x3C] = stext_bmp[0x20];
	stext_bmp[0x3D] = stext_bmp[0x20];
	stext_bmp[0x3E] = stext_bmp[0x20];
	stext_bmp[0x5B] = stext_bmp[0x20];
	stext_bmp[0x5C] = stext_bmp[0x20];
	stext_bmp[0x5D] = stext_bmp[0x20];
	stext_bmp[0x5E] = stext_bmp[0x20];
	stext_bmp[0x5F] = stext_bmp[0x20];
	stext_bmp[0x60] = stext_bmp[0x20];
	for(n = 0x61; n < 0x7B; n++)
		stext_bmp[n] = stext_bmp[n-0x20];
	stext_bmp[0x7B] = stext_bmp[0x20];
	stext_bmp[0x7C] = stext_bmp[0x20];
	stext_bmp[0x7D] = stext_bmp[0x20];
	stext_bmp[0x7E] = stext_bmp[0x20];
	stext_bmp[0x7F] = stext_bmp[0x20];
	
	// CREATE OBJECTS (0800-083A)
	for(i=0; i < 0x3A; i++){
		object_0800_bmp[i] = create_bitmap(16, 16);
		clear_bitmap(object_0800_bmp[i]);
	}
	for(n=0; n < 0x3A; n++){
		for(y=0; y < 16; y++){
			for(x=0; x < 4; x++){
				object_0800_bmp[n]->line[y][(x<<1)] = object_0800[n][(y*4)+x] >> 4;
				object_0800_bmp[n]->line[y][(x<<1)+1] = object_0800[n][(y*4)+x] & 0xF;
			}
		}
		for(y=0; y < 16; y++){
			for(x=0; x < 4; x++){
				object_0800_bmp[n]->line[y][(x<<1)+8] = object_0800[n][(y*4)+64+x] >> 4;
				object_0800_bmp[n]->line[y][(x<<1)+8+1] = object_0800[n][(y*4)+64+x] & 0xF;
			}
		}
	}
	
	// CREATE PRIZE BLOCK FACES
	for(i=0; i < 0x11; i++){
		prize_block_face[i] = create_bitmap(prize_size_x[i], prize_size_y[i]);
		for(n=0; n < (prize_size_x[i] / 8); n++){
			for(y=0; y < prize_size_y[i]; y++){
				for(x=0; x < 4; x++){
					prize_block_face[i]->line[y][(x<<1)+(n*8)] = common[prize_map[i]+(n*(prize_size_y[i]/8))][(y*4)+x] >> 4;
					prize_block_face[i]->line[y][(x<<1)+(n*8)+1] = common[prize_map[i]+(n*(prize_size_y[i]/8))][(y*4)+x] & 0xF;
				}
			}
		}
	}
	
	// CONSTRUCT BLOCKS FOR TILE CONSTRUCTION
	block[0] = create_bitmap(16, 16);
	clear_bitmap(block[0]);
	for(n=1; n < 0x18; n++){
		block[n] = create_bitmap(16, 16);
		for(y=0; y < 8; y++){
			for(x=0; x < 4; x++){
				block[n]->line[y][(x<<1)] = common[(*(short *)&common_map[(n*4)])%0x51][(y*4)+x] >> 4;
				block[n]->line[y][(x<<1)+1] = common[(*(short *)&common_map[(n*4)])%0x51][(y*4)+x] & 0xF;
			}
		}
		for(y=0; y < 8; y++){
			for(x=0; x < 4; x++){
				block[n]->line[y][(x<<1)+8] = common[(*(short *)&common_map[(n*4)+1])%0x51][(y*4)+x] >> 4;
				block[n]->line[y][(x<<1)+8+1] = common[(*(short *)&common_map[(n*4)+1])%0x51][(y*4)+x] & 0xF;
			}
		}
		for(y=0; y < 8; y++){
			for(x=0; x < 4; x++){
				block[n]->line[y+8][(x<<1)] = common[(*(short *)&common_map[(n*4)+2])%0x51][(y*4)+x] >> 4;
				block[n]->line[y+8][(x<<1)+1] = common[(*(short *)&common_map[(n*4)+2])%0x51][(y*4)+x] & 0xF;
			}
		}
		for(y=0; y < 8; y++){
			for(x=0; x < 4; x++){
				block[n]->line[y+8][(x<<1)+8] = common[(*(short *)&common_map[(n*4)+3])%0x51][(y*4)+x] >> 4;
				block[n]->line[y+8][(x<<1)+8+1] = common[(*(short *)&common_map[(n*4)+3])%0x51][(y*4)+x] & 0xF;
			}
		}
	}
	
	for(i=0; i < 0x1E8; i++){
		block[i+0x18] = create_bitmap(16, 16);
		for(n=0; n < 4; n++){
			data_value = swap_endian_16(*(unsigned short *)(&map8x8[(i*8)+(n*2)]));
			if((data_value & 0x7FF) < 0x800){
				pal_offset = ((data_value >> 13) & 3) << 4;
				if(data_value & 0x800){
					if(data_value & 0x1000){
						// rotate
						for(y=0; y < 8; y++){
							for(x=0; x < 4; x++){
								block[i+0x18]->line[y+((n&2)<<2)][(x<<1)+1+((n&1)<<3)] = (glv[((data_value & 0x7FF) << 5) + ((7-y)*4) + 3-x] >> 4) + pal_offset;
								block[i+0x18]->line[y+((n&2)<<2)][(x<<1)+((n&1)<<3)] = (glv[((data_value & 0x7FF) << 5) + ((7-y)*4) + 3-x] & 0xF) + pal_offset;
								
								if((block[i+0x18]->line[y+((n&2)<<2)][(x<<1)+((n&1)<<3)] & 0xF) == 0)
									block[i+0x18]->line[y+((n&2)<<2)][(x<<1)+((n&1)<<3)] = 0x40;
								if((block[i+0x18]->line[y+((n&2)<<2)][(x<<1)+1+((n&1)<<3)] & 0xF) == 0)
									block[i+0x18]->line[y+((n&2)<<2)][(x<<1)+1+((n&1)<<3)] = 0x40;
							}
						}
					}
					else{
						// mirror
						for(y=0; y < 8; y++){
							for(x=0; x < 4; x++){
								block[i+0x18]->line[y+((n&2)<<2)][(x<<1)+1+((n&1)<<3)] = (glv[((data_value & 0x7FF) << 5) + (y*4) + 3-x] >> 4) + pal_offset;
								block[i+0x18]->line[y+((n&2)<<2)][(x<<1)+((n&1)<<3)] = (glv[((data_value & 0x7FF) << 5) + (y*4) + 3-x] & 0xF) + pal_offset;
								
								if((block[i+0x18]->line[y+((n&2)<<2)][(x<<1)+((n&1)<<3)] & 0xF) == 0)
									block[i+0x18]->line[y+((n&2)<<2)][(x<<1)+((n&1)<<3)] = 0x40;
								if((block[i+0x18]->line[y+((n&2)<<2)][(x<<1)+1+((n&1)<<3)] & 0xF) == 0)
									block[i+0x18]->line[y+((n&2)<<2)][(x<<1)+1+((n&1)<<3)] = 0x40;
							}
						}
					}
				}
				else if(data_value & 0x1000){
					// flip
					for(y=0; y < 8; y++){
						for(x=0; x < 4; x++){
							block[i+0x18]->line[y+((n&2)<<2)][(x<<1)+((n&1)<<3)] = (glv[((data_value & 0x7FF) << 5) + ((7-y)*4) + x] >> 4) + pal_offset;
							block[i+0x18]->line[y+((n&2)<<2)][(x<<1)+1+((n&1)<<3)] = (glv[((data_value & 0x7FF) << 5) + ((7-y)*4) + x] & 0xF) + pal_offset;
							
							if((block[i+0x18]->line[y+((n&2)<<2)][(x<<1)+((n&1)<<3)] & 0xF) == 0)
								block[i+0x18]->line[y+((n&2)<<2)][(x<<1)+((n&1)<<3)] = 0x40;
							if((block[i+0x18]->line[y+((n&2)<<2)][(x<<1)+1+((n&1)<<3)] & 0xF) == 0)
								block[i+0x18]->line[y+((n&2)<<2)][(x<<1)+1+((n&1)<<3)] = 0x40;
						}
					}
				}
				else{
					// normal
					for(y=0; y < 8; y++){
						for(x=0; x < 4; x++){
							block[i+0x18]->line[y+((n&2)<<2)][(x<<1)+((n&1)<<3)] = (glv[((data_value & 0x7FF) << 5) + (y*4) + x] >> 4) + pal_offset;
							block[i+0x18]->line[y+((n&2)<<2)][(x<<1)+1+((n&1)<<3)] = (glv[((data_value & 0x7FF) << 5) + (y*4) + x] & 0xF) + pal_offset;
							
							if((block[i+0x18]->line[y+((n&2)<<2)][(x<<1)+((n&1)<<3)] & 0xF) == 0)
								block[i+0x18]->line[y+((n&2)<<2)][(x<<1)+((n&1)<<3)] = 0x40;
							if((block[i+0x18]->line[y+((n&2)<<2)][(x<<1)+1+((n&1)<<3)] & 0xF) == 0)
								block[i+0x18]->line[y+((n&2)<<2)][(x<<1)+1+((n&1)<<3)] = 0x40;
						}
					}
				}
			}
		}
	}
	
	// CONSTRUCT TILES FOR BLITTING
	number_of_tiles = swap_endian_16(*(unsigned short *)(&itm[4]));
	tile = (BITMAP **)malloc(number_of_tiles * sizeof(BITMAP *));
	
	for(i=0; i < number_of_tiles; i++){
		data_address = swap_endian_16(*(unsigned short *)(&itm[6+(i<<1)]));
		//allegro_message("i = 0x%X\ndata_address = 0x%X", i, data_address);
		x = itm[data_address];
		y = itm[data_address+1];
		tile[i] = create_bitmap(x<<4, y<<4);
		clear_bitmap(tile[i]);
		for(n=0; n < (x*y); n++){
			data_value = swap_endian_16(*(unsigned short *)(&itm[data_address+2 + (n<<1)]));
			if((data_value & 0x1FF) == 0){
				draw_sprite(tile[i], block[0], (n%x)*16, (n/x)*16);
			}
			else if(data_value & 0x1000){
				// flip
				draw_sprite_v_flip(tile[i], block[(data_value & 0x1FF)], (n%x)*16, (n/x)*16);
			}
			else{
				// normal
				draw_sprite(tile[i], block[(data_value & 0x1FF)], (n%x)*16, (n/x)*16);
			}
		}
	}
	
	screen_buffer = create_bitmap(res_x, res_y);
	screen_objects = create_bitmap(res_x, res_y);
	
	
	
	// DISPLAY SOME STUFF
	i = 0;	// block
	n = 0;	// tile
	while(!key[KEY_ESC]){
		while(!ticUpdated);
		ticUpdated = 0;
		
		clear_bitmap(screen_buffer);
		clear_bitmap(screen_objects);
		
		if(tic > 4 || (tic > 2 && (key[KEY_LSHIFT] || key[KEY_RSHIFT]))){
			if(key[KEY_S] && i < 0x1FF){
				i++;
				tic = 0;
			}
			else if(key[KEY_A] && i > 0){
				i--;
				tic = 0;
			}
			if(key[KEY_X] && n < number_of_tiles-1){
				n++;
				tic = 0;
			}
			else if(key[KEY_Z] && n > 0){
				n--;
				tic = 0;
			}
		}
		blit(block[i], screen_buffer, 0, 0, 16, 16, 16, 16);
		blit(tile[n], screen_buffer, 0, 0, 16, 48, tile[n]->w, tile[n]->h);
		blit(screen_buffer, screen, 0, 0, 0, 0, res_x, res_y);
		vsync();
	}
	
	
	
	// Check 256 pixels to the left, and 128 pixels above
	// DRAW LEVEL HERE!!
	cam_x = 16;
	cam_y = 0;
	while(key[KEY_ESC]);
	while(!key[KEY_ESC]){
		while(!ticUpdated);
		ticUpdated = 0;
		
		clear_bitmap(screen_buffer);
		clear_bitmap(screen_objects);
		
		check_blocks_up = cam_y - (128-16);
		check_blocks_down = cam_y + res_y;
		check_blocks_left = cam_x - (256-16);
		check_blocks_right = cam_x + res_x;
		
		if(check_blocks_up < 0)
			check_blocks_up = 0;
		if(check_blocks_left < 0)
			check_blocks_left = 0;
		
		for(y = check_blocks_up; y < check_blocks_down; y += 16){
			data_address = swap_endian_16(*(unsigned short *)(&lvl1[8 + ((y>>4)*2)]));
			data_end = swap_endian_16(*(unsigned short *)(&lvl1[10 + ((y>>4)*2)]));
			
			while(data_address < data_end){
				x = swap_endian_16(*(unsigned short *)(&lvl1[data_address + 2]));
				
				if(x >= check_blocks_left){
					n = swap_endian_16(*(unsigned short *)(&lvl1[data_address]));
					
					if(x >= check_blocks_right)
						data_address = data_end;
					
					else if(n < 0x400){
						if(n & 0x200)
							draw_sprite_v_flip(screen_buffer, tile[n&0x1FF], x-cam_x, y-cam_y);
						else
							draw_sprite(screen_buffer, tile[n&0x1FF], x-cam_x, y-cam_y);
					}
					else if(n >= 0x800 && n < 0x83A){
						draw_sprite(screen_buffer, object_0800_bmp[n&0xFF], x-cam_x, y-cam_y);
					}
					else if(n >= 0x900 && n < 0x969){
						if(prize_def_face[n&0xFF] < 0x11){
							if(prize_def_face[n&0xFF] != 4 && prize_def_face[n&0xFF] != 5){
								draw_sprite(screen_buffer, prize_block_face[prize_def_face[n&0xFF]], x-cam_x, y-cam_y);
								if(show_prize && prize_def_spawn[n&0xFF] >= 0x800 && prize_def_spawn[n&0xFF] < 0x83A){
									draw_sprite(screen_buffer, object_0800_bmp[prize_def_spawn[n&0xFF]&0xFF], x-cam_x, y-cam_y-16);
								}
							}
							else{
								if(prize_def_spawn[n&0xFF] >= 0x900 && prize_def_spawn[n&0xFF] < 0x969){
									if(prize_def_face[prize_def_spawn[n&0xFF]&0xFF] < 0x11 && tic & 1){
										draw_sprite(screen_buffer, prize_block_face[prize_def_face[prize_def_spawn[n&0xFF]&0xFF]], x-cam_x, y-cam_y);
										if(show_prize && prize_def_spawn[prize_def_spawn[n&0xFF]&0xFF] >= 0x800 && prize_def_spawn[prize_def_spawn[n&0xFF]&0xFF] < 0x83A){
											draw_sprite(screen_buffer, object_0800_bmp[prize_def_spawn[prize_def_spawn[n&0xFF]&0xFF]&0xFF], x-cam_x, y-cam_y-16);
										}
									}
								}
							}
						}
					}
					else{
						// Display object value
						i = (n >> 12) & 0xF;
						if(i > 9)
							i = (i-10)+'A';
						else
							i += '0';
						draw_sprite(screen_objects, stext_bmp[i], x-cam_x, y-cam_y);
						i = (n >> 8) & 0xF;
						if(i > 9)
							i = (i-10)+'A';
						else
							i += '0';
						draw_sprite(screen_objects, stext_bmp[i], x-cam_x+8, y-cam_y);
						i = (n >> 4) & 0xF;
						if(i > 9)
							i = (i-10)+'A';
						else
							i += '0';
						draw_sprite(screen_objects, stext_bmp[i], x-cam_x, y-cam_y+8);
						i = n & 0xF;
						if(i > 9)
							i = (i-10)+'A';
						else
							i += '0';
						draw_sprite(screen_objects, stext_bmp[i], x-cam_x+8, y-cam_y+8);
						// X value
						/*i = (x >> 12) & 0xF;
						if(i > 9)
							i = (i-10)+'A';
						else
							i += '0';
						draw_sprite(screen_objects, stext_bmp[i], x-cam_x, y-cam_y+8);
						i = (x >> 8) & 0xF;
						if(i > 9)
							i = (i-10)+'A';
						else
							i += '0';
						draw_sprite(screen_objects, stext_bmp[i], x-cam_x+8, y-cam_y+8);
						i = (x >> 4) & 0xF;
						if(i > 9)
							i = (i-10)+'A';
						else
							i += '0';
						draw_sprite(screen_objects, stext_bmp[i], x-cam_x+16, y-cam_y+8);
						i = x & 0xF;
						if(i > 9)
							i = (i-10)+'A';
						else
							i += '0';
						draw_sprite(screen_objects, stext_bmp[i], x-cam_x+24, y-cam_y+8);
						// Y value
						i = (y >> 12) & 0xF;
						if(i > 9)
							i = (i-10)+'A';
						else
							i += '0';
						draw_sprite(screen_objects, stext_bmp[i], x-cam_x, y-cam_y+16);
						i = (y >> 8) & 0xF;
						if(i > 9)
							i = (i-10)+'A';
						else
							i += '0';
						draw_sprite(screen_objects, stext_bmp[i], x-cam_x+8, y-cam_y+16);
						i = (y >> 4) & 0xF;
						if(i > 9)
							i = (i-10)+'A';
						else
							i += '0';
						draw_sprite(screen_objects, stext_bmp[i], x-cam_x+16, y-cam_y+16);
						i = y & 0xF;
						if(i > 9)
							i = (i-10)+'A';
						else
							i += '0';
						draw_sprite(screen_objects, stext_bmp[i], x-cam_x+24, y-cam_y+16);*/
					}
				}
				data_address += 4;
			}
		}
		masked_blit(screen_objects, screen_buffer, 0, 0, 0, 0, res_x, res_y);
		blit(screen_buffer, screen, 0, 0, 0, 0, res_x, res_y);
		vsync();
		
		if(key[KEY_UP]){
			cam_y -= 16;
			if(key[KEY_LSHIFT] || key[KEY_RSHIFT])
				cam_y -= 16;
		}
		if(key[KEY_DOWN]){
			cam_y += 16;
			if(key[KEY_LSHIFT] || key[KEY_RSHIFT])
				cam_y += 16;
		}
		if(key[KEY_LEFT]){
			cam_x -= 16;
			if(key[KEY_LSHIFT] || key[KEY_RSHIFT])
				cam_x -= 16;
		}
		if(key[KEY_RIGHT]){
			cam_x += 16;
			if(key[KEY_LSHIFT] || key[KEY_RSHIFT])
				cam_x += 16;
		}
		if(key[KEY_SPACE]){
			show_prize ^= 1;
			while(key[KEY_SPACE]);
		}
			
		if(cam_x < 16)
			cam_x = 16;
		else if(cam_x > cam_x_max)
			cam_x = cam_x_max;
		if(cam_y < 0)
			cam_y = 0;
		else if(cam_y > cam_y_max)
			cam_y = cam_y_max;
	}
	// END OF DRAW LEVEL STUFF!!
	
	
	
	// EXIT MAP EXPLORER
	destroy_bitmap(screen_buffer);
	destroy_bitmap(screen_objects);
	for(i=0; i < 0x200; i++){
		destroy_bitmap(block[i]);
	}
	for(i=0; i < number_of_tiles; i++){
		destroy_bitmap(tile[i]);
	}
	for(i=0; i < 51; i++){
		destroy_bitmap(stext_bmp[stext_map[i]]);
	}
	for(i=0; i < 0x3A; i++){
		destroy_bitmap(object_0800_bmp[i]);
	}
	for(i=0; i < 0x11; i++){
		destroy_bitmap(prize_block_face[i]);
	}
	free(tile);
}



unsigned short swap_endian_16(unsigned short n){
	return (n << 8) | (n >> 8);
}

unsigned int swap_endian_32(unsigned int n){
	return (n << 24) | ((n & 0xFF00) << 8) | ((n & 0xFF0000) >> 8) | (n >> 24);
}



void load_level(unsigned char n){
	int i;
	int color;
	unsigned int data_address;
	int pp20_id;
	int crunch_size;
	int decrunch_size;
	char level_header[13];
	char string[32];
	
	rom = fopen("jp3.bin", "rb");
	if(rom == NULL){
		allegro_message("Could not open \"JP3.BIN\".");
		allegro_exit();
		exit(0);
	}
	
	pp20_data[0] = 'P';
	pp20_data[1] = 'P';
	pp20_data[2] = '2';
	pp20_data[3] = '0';
	
	// LEVEL NAME
	/*if(level_number > 0){
		fseek(rom, 0xA2BF2 + ((level_number-1)*14), SEEK_SET);
		fread(&data_address, 4, 1, rom);
		data_address = swap_endian_32(data_address);
		fseek(rom, data_address, SEEK_SET);
		fread(string, 1, 32, rom);
		allegro_message("MAP%02X: %s", level_number, string);
	}
	else{
		allegro_message("MAP00: <map screen>");
	}*/
	
	// LEVEL HEADER
	fseek(rom, 0xCB895 + (n*13), SEEK_SET);
	fread(level_header, 1, 13, rom);
	
	// MAP DATA (LVL)
	if(platform == PLATFORM_GENESIS){
		fseek(rom, 0xCEC8A + (level_header[0]*4), SEEK_SET);
		fread(&data_address, 4, 1, rom);
		data_address = swap_endian_32(data_address);
		fseek(rom, data_address, SEEK_SET);
		fread(&crunch_size, 4, 1, rom);
		crunch_size = swap_endian_32(crunch_size);
		if(((crunch_size >> 8) & 0xFF) != 'P'
		 || ((crunch_size >> 16) & 0xFF) != 'A'
		 || ((crunch_size >> 24) & 0xFF) != 'M'){
			// data needs to be decrunched
			fseek(rom, data_address + crunch_size - 4, SEEK_SET);
			fread(&decrunch_size, 4, 1, rom);
			decrunch_size = swap_endian_32(decrunch_size);
			decrunch_size >>= 8;
			fseek(rom, data_address + 4, SEEK_SET);
			fread(&pp20_data[4], 1, crunch_size - 4, rom);
			ppDecrunchMemory(pp20_data, lvl1, crunch_size, decrunch_size, NULL);
		}
		else{
			// store data in current form
			fseek(rom, -4, SEEK_CUR);
			fread(lvl1, 1, 0x8000, rom);
		}
	}
	else{
		amiga_lvl = fopen(filename, "rb");
		fread(&crunch_size, 4, 1, amiga_lvl);
		crunch_size = swap_endian_32(crunch_size);
		if(((crunch_size >> 8) & 0xFF) != 'P'
		 || ((crunch_size >> 16) & 0xFF) != 'A'
		 || ((crunch_size >> 24) & 0xFF) != 'M'){
			// data needs to be decrunched
			fseek(amiga_lvl, crunch_size - 4, SEEK_SET);
			fread(&decrunch_size, 4, 1, amiga_lvl);
			decrunch_size = swap_endian_32(decrunch_size);
			decrunch_size >>= 8;
			fseek(amiga_lvl, 4, SEEK_SET);
			fread(&pp20_data[4], 1, crunch_size - 4, amiga_lvl);
			ppDecrunchMemory(pp20_data, lvl1, crunch_size, decrunch_size, NULL);
		}
		else{
			// store data in current form
			fseek(amiga_lvl, -4, SEEK_CUR);
			fread(lvl1, 1, 0x8000, amiga_lvl);
		}
		fclose(amiga_lvl);
	}
	
	// TILE MAPPINGS DATA (ITM)
	fseek(rom, 0xCF08A + (lvl1[3]*4), SEEK_SET);
	fread(&data_address, 4, 1, rom);
	data_address = swap_endian_32(data_address);
	fseek(rom, data_address, SEEK_SET);
	fread(&crunch_size, 4, 1, rom);
	crunch_size = swap_endian_32(crunch_size);
	if((crunch_size & 0xFF) != 'S'
	 || ((crunch_size >> 8) & 0xFF) != 'M'
	 || ((crunch_size >> 16) & 0xFF) != 'T'
	 || (crunch_size >> 24) != 'I'){
		// data needs to be decrunched
		fseek(rom, data_address + crunch_size - 4, SEEK_SET);
		fread(&decrunch_size, 4, 1, rom);
		decrunch_size = swap_endian_32(decrunch_size);
		decrunch_size >>= 8;
		fseek(rom, data_address + 4, SEEK_SET);
		fread(&pp20_data[4], 1, crunch_size - 4, rom);
		ppDecrunchMemory(pp20_data, itm, crunch_size, decrunch_size, NULL);
	}
	else{
		// store data in current form
		fseek(rom, -4, SEEK_CUR);
		fread(itm, 1, 0x8000, rom);
	}
	
	// SOLIDITY DATA (INS)
	fseek(rom, 0xCF0B6 + (lvl1[3]*4), SEEK_SET);
	fread(&data_address, 4, 1, rom);
	data_address = swap_endian_32(data_address);
	fseek(rom, data_address, SEEK_SET);
	fread(&crunch_size, 4, 1, rom);
	crunch_size = swap_endian_32(crunch_size);
	fread(&pp20_id, 4, 1, rom);
	pp20_id = swap_endian_32(pp20_id);
	if(pp20_id == 0x090A0C0D){
		// data needs to be decrunched
		fseek(rom, data_address + crunch_size - 4, SEEK_SET);
		fread(&decrunch_size, 4, 1, rom);
		decrunch_size = swap_endian_32(decrunch_size);
		decrunch_size >>= 8;
		fseek(rom, data_address + 4, SEEK_SET);
		fread(&pp20_data[4], 1, crunch_size - 4, rom);
		ppDecrunchMemory(pp20_data, ins, crunch_size, decrunch_size, NULL);
	}
	else{
		// store data in current form
		fseek(rom, -8, SEEK_CUR);
		fread(ins, 1, 0x8000, rom);
	}
	
	// ART DATA (GLV)
	fseek(rom, 0xCF0E2 + (lvl1[3]*4), SEEK_SET);
	fread(&data_address, 4, 1, rom);
	data_address = swap_endian_32(data_address);
	fseek(rom, data_address, SEEK_SET);
	fread(&crunch_size, 4, 1, rom);
	crunch_size = swap_endian_32(crunch_size);
	fread(&pp20_id, 4, 1, rom);
	pp20_id = swap_endian_32(pp20_id);
	if(pp20_id == 0x090A0C0D){
		// data needs to be decrunched
		fseek(rom, data_address + crunch_size - 4, SEEK_SET);
		fread(&decrunch_size, 4, 1, rom);
		decrunch_size = swap_endian_32(decrunch_size);
		decrunch_size >>= 8;
		fseek(rom, data_address + 4, SEEK_SET);
		fread(&pp20_data[4], 1, crunch_size - 4, rom);
		ppDecrunchMemory(pp20_data, glv, crunch_size, decrunch_size, NULL);
	}
	else{
		// store data in current form
		fseek(rom, -8, SEEK_CUR);
		fread(glv, 1, 0x8000, rom);
	}
	
	// BLOCK MAPPINGS DATA
	fseek(rom, 0xCF10E + (lvl1[3]*4), SEEK_SET);
	fread(&data_address, 4, 1, rom);
	data_address = swap_endian_32(data_address);
	fseek(rom, data_address, SEEK_SET);
	fread(&crunch_size, 4, 1, rom);
	crunch_size = swap_endian_32(crunch_size);
	fread(&pp20_id, 4, 1, rom);
	pp20_id = swap_endian_32(pp20_id);
	if(pp20_id == 0x090A0C0D){
		// data needs to be decrunched
		fseek(rom, data_address + crunch_size - 4, SEEK_SET);
		fread(&decrunch_size, 4, 1, rom);
		decrunch_size = swap_endian_32(decrunch_size);
		decrunch_size >>= 8;
		fseek(rom, data_address + 4, SEEK_SET);
		fread(&pp20_data[4], 1, crunch_size - 4, rom);
		ppDecrunchMemory(pp20_data, map8x8, crunch_size, decrunch_size, NULL);
	}
	else{
		// store data in current form
		fseek(rom, -8, SEEK_CUR);
		fread(map8x8, 1, 0x8000, rom);
	}
	
	// PALETTE 0 DATA
	fseek(rom, 0x111726 + (level_header[2]*4), SEEK_SET);
	fread(&data_address, 4, 1, rom);
	data_address = swap_endian_32(data_address);
	fseek(rom, data_address, SEEK_SET);
	for(i=0; i < 16; i++){
		fread(&color, 2, 1, rom);
		color = swap_endian_16(color);
		pal0[i].r = (color & 0xE) << 2;
		pal0[i].g = ((color >> 4) & 0xE) << 2;
		pal0[i].b = ((color >> 8) & 0xE) << 2;
		set_color(i+0x00, &pal0[i]);
	}
	
	// PALETTE 1 DATA
	fseek(rom, 0x111726 + (level_header[3]*4), SEEK_SET);
	fread(&data_address, 4, 1, rom);
	data_address = swap_endian_32(data_address);
	fseek(rom, data_address, SEEK_SET);
	for(i=0; i < 16; i++){
		fread(&color, 2, 1, rom);
		color = swap_endian_16(color);
		pal1[i].r = (color & 0xE) << 2;
		pal1[i].g = ((color >> 4) & 0xE) << 2;
		pal1[i].b = ((color >> 8) & 0xE) << 2;
		set_color(i+0x10, &pal1[i]);
	}
	
	// PALETTE 2 DATA
	fseek(rom, 0x111726 + (level_header[4]*4), SEEK_SET);
	fread(&data_address, 4, 1, rom);
	data_address = swap_endian_32(data_address);
	fseek(rom, data_address, SEEK_SET);
	for(i=0; i < 16; i++){
		fread(&color, 2, 1, rom);
		color = swap_endian_16(color);
		pal2[i].r = (color & 0xE) << 2;
		pal2[i].g = ((color >> 4) & 0xE) << 2;
		pal2[i].b = ((color >> 8) & 0xE) << 2;
		set_color(i+0x20, &pal2[i]);
	}
	
	// PALETTE 3 DATA
	fseek(rom, 0x111726 + (level_header[5]*4), SEEK_SET);
	fread(&data_address, 4, 1, rom);
	data_address = swap_endian_32(data_address);
	fseek(rom, data_address, SEEK_SET);
	for(i=0; i < 16; i++){
		fread(&color, 2, 1, rom);
		color = swap_endian_16(color);
		pal3[i].r = (color & 0xE) << 2;
		pal3[i].g = ((color >> 4) & 0xE) << 2;
		pal3[i].b = ((color >> 8) & 0xE) << 2;
		set_color(i+0x30, &pal3[i]);
	}
	
	// COMMON BLOCKS
	fseek(rom, 0xCF166, SEEK_SET);
	fread(&crunch_size, 4, 1, rom);
	crunch_size = swap_endian_32(crunch_size);
	fread(&pp20_id, 4, 1, rom);
	pp20_id = swap_endian_32(pp20_id);
	if(pp20_id == 0x090A0C0D){
		// data needs to be decrunched
		fseek(rom, 0xCF166 + crunch_size - 4, SEEK_SET);
		fread(&decrunch_size, 4, 1, rom);
		decrunch_size = swap_endian_32(decrunch_size);
		decrunch_size >>= 8;
		fseek(rom, 0xCF166 + 4, SEEK_SET);
		fread(&pp20_data[4], 1, crunch_size - 4, rom);
		ppDecrunchMemory(pp20_data, common[0x00], crunch_size, decrunch_size, NULL);
	}
	else{
		// store data in current form
		fseek(rom, -8, SEEK_CUR);
		fread(common[0x00], 1, 0x99*0x20, rom);
	}
	fseek(rom, 0x29940, SEEK_SET);
	fread(common[0x51], 1, 0x20*0x48, rom);
	
	// COMMON BLOCK MAPPINGS
	fseek(rom, 0x1031C2, SEEK_SET);
	fread(common_map, 2, 0x60, rom);
	for(i=0; i < 0x60; i++)
		common_map[i] = swap_endian_16(common_map[i]);
	fseek(rom, 0xA71D2, SEEK_SET);
	for(i=0; i < 0x11; i++){
		fread(&prize_map[i], 4, 1, rom);
		prize_map[i] = swap_endian_32(prize_map[i]);
		if(prize_map[i] != 0){
			if(prize_map[i] & 0x80000000){
				prize_map[i] -= 0x687;
				prize_map[i] &= 0xFFFF;
			}
			else{
				prize_map[i] >>= 5;
				prize_map[i] -= 0xDEE;
				prize_map[i] -= 0x687;
			}
		}
		fread(&prize_size_x[i], 2, 1, rom);
		fread(&prize_size_y[i], 2, 1, rom);
		prize_size_x[i] = swap_endian_16(prize_size_x[i]);
		prize_size_y[i] = swap_endian_16(prize_size_y[i]);
	}
	
	// PRIZE BLOCK DEFINITIONS
	fseek(rom, 0xA725A, SEEK_SET);
	for(i=0; i < 0x69; i++){
		fread(&prize_def_face[i], 2, 1, rom);
		fread(&prize_def_spawn[i], 2, 1, rom);
		prize_def_face[i] = swap_endian_16(prize_def_face[i]);
		prize_def_spawn[i] = swap_endian_16(prize_def_spawn[i]);
	}
	
	// OBJECTS (0800-083A)
	for(i=0; i < 0x3A; i++){
		fseek(rom, 0xC615C + (i*4), SEEK_SET);
		fread(&data_address, 4, 1, rom);
		data_address = swap_endian_32(data_address) >> 16;
		fseek(rom, data_address + 0xC6158, SEEK_SET);
		fread(&data_address, 4, 1, rom);
		while((data_address & 0xFF) != 0){
			fseek(rom, -2, SEEK_CUR);
			fread(&data_address, 4, 1, rom);
		}
		data_address = swap_endian_32(data_address);
		fseek(rom, data_address, SEEK_SET);
		fread(object_0800[i], 1, 0x80, rom);
	}
	
	// MOON
	fseek(rom, 0x2A840, SEEK_SET);
	fread(object_0800[0x1D], 1, 0x80, rom);
	fseek(rom, 0x2A840, SEEK_SET);
	fread(common[0x00], 1, 0x80, rom);
	
	// SURVEILLANCE BEACON
	fseek(rom, 0x2A620, SEEK_SET);
	fread(object_0800[0x39], 1, 0x80, rom);
	
	// SMALL TEXT
	fseek(rom, 0x96A6C, SEEK_SET);
	fread(stext, 1, 0x660, rom);
	
	// MISC
	set_color(0x40, &pal0[0]);
	cam_x_max = swap_endian_16(*(short *)(&lvl1[4])) - res_x - 16;
	cam_y_max = swap_endian_16(*(short *)(&lvl1[6])) - res_y;
	
	fclose(rom);
}
